#include<netinet/in.h>
#include<sys/time.h>
#include<sys/socket.h>
#include<arpa/inet.h>
#include<unistd.h>
#include<string.h>
#include<stdlib.h>
#include<stdio.h>
#include<netdb.h>

char puffer[4096];
struct struktur
{
  unsigned long count;
  struct timeval tv;
  char last[1];
};

unsigned long anzahl=10;
int gross=64;

int main(int argc,char **argv)
{
  struct sockaddr_in remote; 
  unsigned long i;
  struct timeval tv;
  int fd;
  int r;
  char *host,*portstr;
  short port;
  /* Aufbauen der Verbindung */
  fd=socket(PF_INET,SOCK_DGRAM,17); 
  if(fd<0)
  { perror("socket");exit(1); 
  }

  while((r=getopt(argc,argv,"l:n:"))!=-1)
  {
    switch(r)
    {
    case 'l': gross=atoi(optarg);
              break;
    case 'n': anzahl=atol(optarg);
	      break;
    default:
         fprintf(stderr,"Aufruf: sender -l last -n zahl host port\n");
         exit(1);
    }
  }
  if(argc-optind<2)
  {
    fprintf(stderr,"Aufruf: sender -l last -n zahl host port\n");
    exit(1);
  }
  host=argv[optind]; 
  portstr=argv[optind+1];
  r=inet_aton(host,&remote.sin_addr);
  if(!r)
  {
     struct hostent *hp = gethostbyname(host);
     if(hp==NULL)
     {
        fprintf(stderr,"Rechner %s nicht gefunden\n",host);
        exit(1);
     }
     memcpy(&remote.sin_addr,hp->h_addr,hp->h_length); 
  }
  remote.sin_family=AF_INET;
  remote.sin_port=htons(atoi(portstr));

  /* Sende */
  for(i = 0;i< anzahl;i++)
  {
     struct struktur *s = (struct struktur *)puffer;
     s->count = htonl(i);
     gettimeofday(&tv,NULL);
     s->tv.tv_sec = htonl(tv.tv_sec);
     s->tv.tv_usec = htonl(tv.tv_usec);
     r = sendto(fd,puffer,gross,0,(struct sockaddr *)&remote,sizeof(remote));
     if(r<0) perror("sendto");
  }
  close(fd);
}
